Subject: [OAUTH-WG] Downgrade attacks on PKCE

From: Daniel Fett <[email-masked]>
Date: Sat, 30 May 2020 09:58:49 +0200

Hi all,

Aaron, Dick, Torsten and I today discussed the downgrade attacks on PKCE
[1] and how to mitigate them in OAuth 2.1 and 2.0. We came to the
conclusion that we have two options:

*1. "Static" Solution*

For every client_id that is registered with an AS, the AS MUST either
always enforce the use of PKCE or always enforce the use of nonce.
Whether PKCE or nonce is enforced can be part of the client registration
or configured in other ways.

In other words: A single client is not allowed to switch between using
PKCE and using nonce.

Note that the client is allowed to use the respective other mechanism on
top of the enforced one.

Properties:

  * Easy to understand mitigation.
  * Implementation is mainly a new data field and a check in the
    authorization request.
  * Not compatible to deployments where clients sometimes use nonce and
    sometimes use PKCE with the same client_id. *
    ***

**

*2. "Dynamic" Solution*

Each AS that supports PKCE MUST check whether a code challenge is
contained in the authorization request. This information MUST be bound
to the code that is issued.

When a code arrives at the token endpoint, the AS MUST do the following
check:

 1. If there was a code_challenge in the authorization request for which
    this code was issued, there must be a code_verifier in the token
    request and it must be verified according to RFC7636. (This is no
    change from the current behavior in RFC7636.)
 2. If there was no code_challenge in the authorization request, any
    request to the token endpoint containing a code_verifier MUST be
    rejected.

Properties:

  * No change in behavior needed for properly implemented clients.
    Backwards compatible for all existing deployments.
  * Implementation is mainly some logic for the authorization endpoint,
    token endpoint, and a new data field in the authorization session
    maintained by the AS.
  * Slightly more complex to implement for the AS, maybe.

We would like to hear the feedback from the working group on these two
solutions before proceeding to propose wording for the affected documents.

[1] https://danielfett.de/2020/05/16/pkce-vs-nonce-equivalent-or-not/

-Daniel

---

From: Neil Madden <[email-masked]>
Date: Sat, 30 May 2020 12:38:44 +0100

We (ForgeRock) already support solution 1 as a configuration option, but I prefer solution 2 and have raised a ticket for us to implement it. For us at least it’s a trivial fix and seems more robust against configuration errors.

— Neil

> On 30 May 2020, at 08:58, Daniel Fett <[email-masked]> wrote:
> 
> Hi all,
> 
> Aaron, Dick, Torsten and I today discussed the downgrade attacks on PKCE [1] and how to mitigate them in OAuth 2.1 and 2.0. We came to the conclusion that we have two options:
> 
> 1. "Static" Solution
> 
> For every client_id that is registered with an AS, the AS MUST either always enforce the use of PKCE or always enforce the use of nonce. Whether PKCE or nonce is enforced can be part of the client registration or configured in other ways.
> 
> In other words: A single client is not allowed to switch between using PKCE and using nonce.
> 
> Note that the client is allowed to use the respective other mechanism on top of the enforced one.
> 
> Properties:
> Easy to understand mitigation.
> Implementation is mainly a new data field and a check in the authorization request.
> Not compatible to deployments where clients sometimes use nonce and sometimes use PKCE with the same client_id. 
> 2. "Dynamic" Solution
> 
> Each AS that supports PKCE MUST check whether a code challenge is contained in the authorization request. This information MUST be bound to the code that is issued.
> 
> When a code arrives at the token endpoint, the AS MUST do the following check:
> 
> If there was a code_challenge in the authorization request for which this code was issued, there must be a code_verifier in the token request and it must be verified according to RFC7636. (This is no change from the current behavior in RFC7636.)
> If there was no code_challenge in the authorization request, any request to the token endpoint containing a code_verifier MUST be rejected.
> Properties:
> 
> No change in behavior needed for properly implemented clients. Backwards compatible for all existing deployments.
> Implementation is mainly some logic for the authorization endpoint, token endpoint, and a new data field in the authorization session maintained by the AS.
> Slightly more complex to implement for the AS, maybe.
> We would like to hear the feedback from the working group on these two solutions before proceeding to propose wording for the affected documents.
> 
> [1] https://danielfett.de/2020/05/16/pkce-vs-nonce-equivalent-or-not/ <https://danielfett.de/2020/05/16/pkce-vs-nonce-equivalent-or-not/>
> 
> -Daniel
> 
> _______________________________________________
> OAuth mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/oauth

---

From: Ryan Kelly <[email-masked]>
Date: Mon, 1 Jun 2020 10:03:33 +1000

> conclusion that we have two options:
[..snip..]
> contained in the authorization request. This information MUST be bound to
> the code that is issued.
>
>    1. If there was a code_challenge in the authorization request for
>    which this code was issued, there must be a code_verifier in the token
>    request and it must be verified according to RFC7636. (This is no change
>    from the current behavior in RFC7636.)
>    request to the token endpoint containing a code_verifier MUST be rejected.
>
> Properties:
>
>    - No change in behavior needed for properly implemented clients.
>    - Implementation is mainly some logic for the authorization endpoint,
>    - Slightly more complex to implement for the AS, maybe.
>

When we added PKCE support in Firefox Accounts, we implemented the
suggested check (2) above purely as a defensive-coding measure, expecting
that it might help us catch buggy clients. I think it makes sense to add as
a required behaviour since it seems like a pretty clear signal of
mismatched expectations between client and server.

  Cheers,

     Ryan

---

From: Filip Skokan <[email-masked]>
Date: Mon, 1 Jun 2020 08:27:48 +0200

I also have #2 in place since ages like others have, or are about to. 

It just made sense to me to have it that way based on PKCE Section 4.4.  The challenge and method are bound to the code to be verified later. 

When the server issues the authorization code in the authorization
   response, it MUST associate the "code_challenge" and
   "code_challenge_method" values with the authorization code so it can
   be verified later.

“Empty”, “Undefined” and the like are values to be verified too. The trigger to verify PKCE in the token request is presence of pkce params in either the code bound data or the request. Which would be the case described in Daniel’s blog post. 

- Filip

Odesláno z iPhonu

> 30. 5. 2020 v 9:59, Daniel Fett <[email-masked]>:
> 
> 
> Hi all,
>